using System;
using System.Drawing;
using System.Text;

namespace Andrei.CommonControlsWeb
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	public class clsHideEmail
	{
		private string m_strEmail ;
		public clsHideEmail(string Email)
		{
			//TODO: check for email validity
			m_strEmail = Email;

		}
		public string JavaScriptDocumentWrite(string Text)
		{

		
			int intWhere = m_strEmail.IndexOf("@");
			if(intWhere <0 )
				return "";
			string strFirst = m_strEmail.Substring(0,intWhere);
			string strLast = m_strEmail.Substring(intWhere+1);
			StringBuilder sb=new StringBuilder("<script>");
			sb.Append(Environment.NewLine);
			sb.Append("<!--");
			sb.Append(Environment.NewLine);
			sb.Append("var addr1 = 'mailto:';");
			sb.Append(Environment.NewLine);
			sb.Append("var addr2 = '" + strFirst + "';");
			sb.Append(Environment.NewLine);
			sb.Append("var addr3 = '@';");
			sb.Append(Environment.NewLine);
			sb.Append("var addr4 = '" + strLast + "';");
			sb.Append(Environment.NewLine);
			sb.Append("document.write(' <a href =' + addr1 + addr2 + addr3 + addr4 + '>') ;");
			sb.Append(Environment.NewLine);
			sb.Append("document.write(' "+ Text + "')");
			sb.Append(Environment.NewLine);
			sb.Append("document.write('</a>')");
			sb.Append(Environment.NewLine);
			sb.Append("//-->");
			sb.Append(Environment.NewLine);
			sb.Append("</script>");
			return sb.ToString();

		}
		public string JavaScriptDocumentWrite()
		{
			return JavaScriptDocumentWrite("send email");
		}
		public string JavaScriptFunctionName
		{
			get
			{
				string EmailFunction = m_strEmail.Replace("@","");
				EmailFunction = EmailFunction.Replace(".","");
				return "sendMail_" + EmailFunction + "()";
			}
		}
		public string JavaScriptSendEmail()
		{
			StringBuilder sb=new StringBuilder("<script>");
			sb.Append(Environment.NewLine);
			sb.Append("function " + JavaScriptFunctionName) ;
			sb.Append(Environment.NewLine);
			sb.Append("{");
			sb.Append(Environment.NewLine);
			sb.Append("var ml =String.fromCharCode(");
			foreach(char c in "mailto:".ToCharArray())
			{
				sb.Append((int)c);
				sb.Append(",");
			}
			foreach(char c in m_strEmail.ToCharArray())
			{
				sb.Append((int)c);
				sb.Append(",");
			}
			//remove last ,
			sb = sb.Replace(",","",sb.Length-1,1);
			sb.Append(Environment.NewLine);
			sb.Append(");");

			sb.Append(Environment.NewLine);
			sb.Append("window.open(ml);");
			sb.Append(Environment.NewLine);
			sb.Append("}");
			sb.Append(@"</script>");
			return sb.ToString();
		}
		public Bitmap imgEmail()
		{
			return imgEmail(Color.Blue,new Font("Arial",10),Color.White);
		}
		public Bitmap imgEmail(Color BackgroundColor,Font TextFont,Color TextColor)
		{
			Bitmap b=new Bitmap(10,10);
			Graphics g =Graphics.FromImage(b);
			SizeF s = g.MeasureString(m_strEmail,TextFont);
			//redimension the bitmap
			b = new Bitmap((int)s.Width+1,(int)s.Height+1);
			//reinitilize the image
			g =Graphics.FromImage(b);
			g.Clear(BackgroundColor);
			
			g.DrawString(m_strEmail,TextFont,new SolidBrush(TextColor),0,0);
			g.Flush();
			g.Dispose();
			return b;
			
			
		}
	}
}
