using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;

namespace Andrei.CommonControlsWeb
{
	/// <summary>
	/// Summary description for wcHideEmail.
	/// </summary>
	[DefaultProperty("Email"), 
	ToolboxData("<{0}:wcHideEmail runat=server></{0}:wcHideEmail>")]
	public class wcHideEmail : System.Web.UI.WebControls.WebControl,INamingContainer
	{
		
	
		[Bindable(true), 
		Category("Appearance"), 
		DefaultValue("")] 
		public string Email 
		{
			get
			{
				string s = (string)ViewState["Email"];
				return (s == null) ? "cursval@infovalutar.ro" : s;
			}

			set
			{
				ViewState["Email"]=value;
			}
		}
		
		public string TextToDisplay
		{
			get
			{
				string s = (string)ViewState["TextToDisplay"];
				return (s == null) ? "Ignat Andrei" : s;
			}

			set
			{
				ViewState["TextToDisplay"]=value;
			}
		}
		


		/// <summary> 
		/// Render this control to the output parameter specified.
		/// </summary>
		/// <param name="output"> The HTML writer to write out to </param>
		protected override void Render(HtmlTextWriter output)
		{
			
			clsHideEmail c=new clsHideEmail(this.Email);
			string strOutput= "<a href='javascript:" + c.JavaScriptFunctionName +"'>"+ TextToDisplay + "</a>";
			output.Write(strOutput);
			if(!this.Page.IsStartupScriptRegistered(c.JavaScriptFunctionName))
			{
				this.Page.RegisterStartupScript(c.JavaScriptFunctionName,c.JavaScriptSendEmail());

			}
		}
	}
}
